#!/bin/bash

ROOT=/gpfs/scratch/bsc32/bsc032756/APPS/NEMO5_2024
ROOT_NEMO="$ROOT/nemo5_src"
ROOT_XIOS="$ROOT/xios_2311_src"
ROOT_RUNDIR="$ROOT/RUNDIR"

# RUN INTEL MPI:
ENV_FILE="env-intel-mpi.sh"

./RUN/run_nemo.sh  \
        --nemo "${ROOT_NEMO}/cfgs/GLO-INTEL-IMPI-FRO/EXP00" \
        --xios "${ROOT_XIOS}/new_mn5_gpp_intel/bin/xios_server.exe" \
        --env "${ENV_FILE}" \
        --rundir ${ROOT_RUNDIR}/TEST/ORCA025/IMPI \
        --resolution ORCA025-FRO --force

# RUN INTEL+OpenMPI:
ENV_FILE="env-intel-ompi.sh"

./RUN/run_nemo.sh  \
        --nemo "${ROOT_NEMO}/cfgs/GLO-INTEL-OMPI-FRO/EXP00" \
        --xios "${ROOT_XIOS}/new_mn5_gpp_intel_openmpi/bin/xios_server.exe" \
        --env "${ENV_FILE}" \
        --rundir ${ROOT_RUNDIR}/TEST/ORCA025/OMPI \
        --resolution ORCA025-FRO --force


# END
